"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Footer = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _designparams = require("../../designparams");

var _padding = require("./padding");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Footer
 *
 * The Footer component adds a small margin to all its children
 *
 * Note: the footer items are rendered from right to left!! This also causes the
 * focus to land on the most important button first. If focus behaviour needs to
 * be changed, please use tab-index or the order CSS property on the footer
 * children, as changing the order behaviour of the children will cause too much
 * breaking changes.
 */
var Footer = _styledComponents.default.div.withConfig({
  displayName: "Footer",
  componentId: "sc-1ucmlb9-0"
})(["display:flex;flex-direction:row-reverse;box-sizing:border-box;width:100%;height:100%;align-items:center;justify-content:flex-start;padding:0 ", ";>:not(:first-child){margin-right:", ";}box-shadow:", ";transition:box-shadow 0.2s ease-in-out;"], _padding.DIALOG_PADDING, _designparams.spacing.medium, _ref => {
  var {
    shadowHidden,
    theme
  } = _ref;
  return shadowHidden ? 'none' : theme.shadow.dialogHeaderFooter;
});

exports.Footer = Footer;