"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  Expandable: true
};
exports.Expandable = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Transition = require("../Transition");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _ArrowIcon = require("./ArrowIcon");

Object.keys(_ArrowIcon).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _ArrowIcon[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _ArrowIcon[key];
    }
  });
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Header = _styledComponents.default.div.withConfig({
  displayName: "Expandable__Header",
  componentId: "sc-1a0ucp6-0"
})(["cursor:pointer;"]);

var ExpandableHeader = _ref => {
  var {
    onClick,
    children
  } = _ref;
  return /*#__PURE__*/_react.default.createElement(Header, {
    onClick: onClick
  }, children);
};

var Expandable = _ref2 => {
  var {
    initialExpanded = false,
    children
  } = _ref2,
      props = _objectWithoutProperties(_ref2, ["initialExpanded", "children"]);

  var [expanded, setExpanded] = (0, _react.useState)(initialExpanded);
  var toggleExpanded = (0, _react.useCallback)(() => {
    setExpanded(!expanded);
  }, [expanded]);
  var {
    header,
    body
  } = children;
  return /*#__PURE__*/_react.default.createElement("div", props, /*#__PURE__*/_react.default.createElement(ExpandableHeader, {
    onClick: toggleExpanded
  }, header(expanded)), /*#__PURE__*/_react.default.createElement(_Transition.FoldTransition, {
    expanded: expanded
  }, body));
};

exports.Expandable = Expandable;