"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Link = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _designparams = require("../designparams");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var LinkNative = _styledComponents.default.a.withConfig({
  displayName: "Link__LinkNative",
  componentId: "kbc77n-0"
})(["padding:0;border-color:transparent;cursor:pointer;height:auto;font-weight:600;text-decoration:none;color:", ";&:hover{color:", ";}&:focus{outline:none;}&:active{color:", ";}"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.textLink();
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.textLinkHover();
}, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.textLinkHover();
});

var LinkButton = _styledComponents.default.button.withConfig({
  displayName: "Link__LinkButton",
  componentId: "kbc77n-1"
})(["padding:0;border:none;background-color:transparent;cursor:pointer;height:auto;font-size:inherit;font-weight:600;color:", ";&:hover{color:", ";}&:focus{outline:none;}&:active{color:", ";}", ""], _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.textLink();
}, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.color.textLinkHover();
}, _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.color.textLinkHover();
}, _ref7 => {
  var {
    disabled
  } = _ref7;
  return disabled === true ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;"], _designparams.opacity[48]) : undefined;
});

var Link = _ref8 => {
  var {
    children
  } = _ref8,
      props = _objectWithoutProperties(_ref8, ["children"]);

  if (props.variant === 'a') {
    return /*#__PURE__*/_react.default.createElement(LinkNative, props, children);
  }

  return /*#__PURE__*/_react.default.createElement(LinkButton, _extends({}, props, {
    type: "button"
  }), children);
};

exports.Link = Link;