"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Menu = exports.MenuItem = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _practicalReactComponentsIcons = require("practical-react-components-icons");

var _designparams = require("../designparams");

var _Typography = require("../Typography");

var _Icon = require("../Icon");

var _BaseMenu = require("./BaseMenu");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var MenuItem = _styledComponents.default.div.withConfig({
  displayName: "Menu__MenuItem",
  componentId: "sc-7nai50-0"
})(["display:flex;align-items:center;padding:0 ", ";> *{margin-right:", ";}height:", ";border-bottom:", ";", ""], _designparams.spacing.large, _designparams.spacing.large, _ref => {
  var {
    compact
  } = _ref;
  return compact ? _designparams.componentSize.small : _designparams.componentSize.medium;
}, _ref2 => {
  var {
    divider,
    theme
  } = _ref2;
  return divider === true ? "1px solid ".concat(theme.color.element12()) : 0;
}, _ref3 => {
  var {
    danger,
    theme
  } = _ref3;
  return danger === true ? (0, _styledComponents.css)(["color:", ";"], theme.color.textError()) : undefined;
});

exports.MenuItem = MenuItem;
var MenuItemIcon = (0, _styledComponents.default)(_Icon.Icon).withConfig({
  displayName: "Menu__MenuItemIcon",
  componentId: "sc-7nai50-1"
})(["color:", ";"], _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.text05();
});

/**
 * Menu
 *
 * Forwards props to BaseMenu
 */
var Menu = /*#__PURE__*/(0, _react.memo)(_ref5 => {
  var {
    icon: buttonIcon = _practicalReactComponentsIcons.MoreVertIcon,
    items,
    compact: compactFromProps
  } = _ref5,
      props = _objectWithoutProperties(_ref5, ["icon", "items", "compact"]);

  var {
    compact: compactFromTheme
  } = (0, _styledComponents.useTheme)();
  var compact = compactFromProps !== null && compactFromProps !== void 0 ? compactFromProps : compactFromTheme;

  var button = /*#__PURE__*/_react.default.createElement(_BaseMenu.MenuButtonIconContainer, null, /*#__PURE__*/_react.default.createElement(_BaseMenu.MenuButtonIcon, {
    icon: buttonIcon
  }), /*#__PURE__*/_react.default.createElement(_BaseMenu.MenuButtonHalo, null));
  /**
   * Creates array of components using MenuItem to
   * forward to Base Menu
   */


  var components = (0, _react.useMemo)(() => items.map(item => {
    var {
      icon,
      label,
      divider,
      danger
    } = item;
    var menuItemContent = icon !== undefined ? /*#__PURE__*/_react.default.createElement(MenuItemIcon, {
      icon: icon,
      size: "small"
    }) : undefined;
    return _objectSpread({
      component: /*#__PURE__*/_react.default.createElement(MenuItem, {
        divider: divider,
        danger: danger,
        compact: compact
      }, menuItemContent, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
        variant: "navigation-label"
      }, label))
    }, item);
  }), [compact, items]);
  return /*#__PURE__*/_react.default.createElement(_BaseMenu.BaseMenu, _extends({
    button: button,
    components: components
  }, props));
});
exports.Menu = Menu;
Menu.displayName = 'Menu';