"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseSelectSelector = exports.SelectInsideContainer = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _Icon = require("../Icon");

var _icons = require("./icons");

var _designparams = require("../designparams");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var SelectInsideContainer = _styledComponents.default.div.withConfig({
  displayName: "BaseSelectSelector__SelectInsideContainer",
  componentId: "g642r0-0"
})(["display:flex;flex-direction:row;align-items:center;justify-content:space-between;height:100%;width:100%;"]);

exports.SelectInsideContainer = SelectInsideContainer;

var SelectInput = _styledComponents.default.div.withConfig({
  displayName: "BaseSelectSelector__SelectInput",
  componentId: "g642r0-1"
})(["display:flex;align-items:center;min-height:", ";color:", ";background-color:", ";padding:2px;border:0 solid transparent;border-radius:", ";", " font-family:", ";font-size:", ";line-height:", ";text-align:left;cursor:pointer;", "{padding:", ";}", " > *:last-child > svg{width:100%;height:100%;cursor:pointer;background-color:transparent;fill:", ";}&:hover{background-color:", ";", "}&:focus-within{outline:none;", "}&:active{background-color:", ";border:none;padding:2px;}", " ", ";"], _ref => {
  var {
    compact
  } = _ref;
  return compact ? _designparams.componentSize.small : _designparams.componentSize.medium;
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text01();
}, _ref3 => {
  var {
    variant,
    theme
  } = _ref3;
  return variant === 'filled' || variant === 'framed' ? theme.color.background02() : 'transparent';
}, _designparams.shape.radius.medium, _ref4 => {
  var {
    variant,
    theme
  } = _ref4;
  return variant === 'framed' ? (0, _styledComponents.css)(["padding:1px;border:1px solid ", ";"], theme.color.element01()) : undefined;
}, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.font.family;
}, _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.font.size.regular;
}, _ref7 => {
  var {
    theme
  } = _ref7;
  return theme.font.lineHeight.large;
}, SelectInsideContainer, _ref8 => {
  var {
    compact
  } = _ref8;
  return compact ? "0 ".concat(_designparams.spacing.small, " 0 ").concat(_designparams.spacing.medium) : "0 ".concat(_designparams.spacing.medium);
}, SelectInsideContainer, _ref9 => {
  var {
    theme
  } = _ref9;
  return theme.color.element01();
}, _ref10 => {
  var {
    variant,
    theme
  } = _ref10;
  return variant === 'filled' || variant === 'framed' ? theme.color.background01() : theme.color.background02();
}, _ref11 => {
  var {
    variant,
    theme
  } = _ref11;
  return variant === 'framed' ? (0, _styledComponents.css)(["padding:0;border:2px solid ", ";"], theme.color.element01()) : undefined;
}, _ref12 => {
  var {
    openedFocus,
    visibleFocus,
    variant,
    theme
  } = _ref12;
  return openedFocus ? (0, _styledComponents.css)(["background-color:", ";border:none;padding:2px;"], theme.color.background01()) : visibleFocus ? (0, _styledComponents.css)(["background-color:", ";border:2px solid ", ";padding:0;"], variant === 'filled' || variant === 'framed' ? theme.color.background01() : 'transparent', theme.color.textPrimary()) : undefined;
}, _ref13 => {
  var {
    theme
  } = _ref13;
  return theme.color.background01();
}, _ref14 => {
  var {
    disabled
  } = _ref14;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;"], _designparams.opacity[48]) : undefined;
}, _ref15 => {
  var {
    theme,
    hasError
  } = _ref15;
  return hasError ? (0, _styledComponents.css)(["&,&:hover,&:focus{background-color:", ";border-color:", ";}"], theme.color.backgroundError(), theme.color.elementError()) : undefined;
});

var BaseSelectSelector = _ref16 => {
  var {
    onToggleOpen,
    open,
    children,
    compact: compactFromProps,
    disabled = false,
    variant = 'filled',
    hasError = false,
    visibleFocus = false
  } = _ref16,
      props = _objectWithoutProperties(_ref16, ["onToggleOpen", "open", "children", "compact", "disabled", "variant", "hasError", "visibleFocus"]);

  var {
    compact: compactFromTheme
  } = (0, _styledComponents.useTheme)();
  var compact = compactFromProps !== null && compactFromProps !== void 0 ? compactFromProps : compactFromTheme;
  return /*#__PURE__*/_react.default.createElement(SelectInput, _extends({
    role: "button",
    tabIndex: 0,
    onClick: onToggleOpen,
    compact: compact,
    disabled: disabled,
    variant: variant,
    openedFocus: open,
    visibleFocus: visibleFocus,
    hasError: hasError
  }, props), /*#__PURE__*/_react.default.createElement(SelectInsideContainer, null, children, /*#__PURE__*/_react.default.createElement(_Icon.Icon, {
    icon: open ? _icons.ArrowUpIcon : _icons.ArrowDownIcon
  })));
};

exports.BaseSelectSelector = BaseSelectSelector;