"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Select = Select;
exports.SelectField = exports.PlaceholderContainer = exports.LabelContainer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _BaseSelect = require("./BaseSelect");

var _withField = require("../utils/withField");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var LabelContainer = _styledComponents.default.span.withConfig({
  displayName: "Select__LabelContainer",
  componentId: "sc-10ei6xa-0"
})(["overflow:hidden;text-overflow:ellipsis;user-select:none;"]);

exports.LabelContainer = LabelContainer;
var PlaceholderContainer = (0, _styledComponents.default)(LabelContainer).withConfig({
  displayName: "Select__PlaceholderContainer",
  componentId: "sc-10ei6xa-1"
})(["color:", ";"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.text05();
});
exports.PlaceholderContainer = PlaceholderContainer;

function Select(_ref2) {
  var {
    value: currentValue,
    options,
    placeholder = ''
  } = _ref2,
      props = _objectWithoutProperties(_ref2, ["value", "options", "placeholder"]);

  var textOptions = (0, _react.useMemo)(() => options.map(_ref3 => {
    var {
      value,
      label,
      disabled
    } = _ref3;
    return {
      value,
      disabled,
      component: label
    };
  }), [options]);
  var currentLabel = (0, _react.useMemo)(() => {
    var _options$find;

    return (_options$find = options.find(_ref4 => {
      var {
        value
      } = _ref4;
      return value === currentValue;
    })) === null || _options$find === void 0 ? void 0 : _options$find.label;
  }, [currentValue, options]);
  var label = (0, _react.useMemo)(() => currentLabel === undefined ? /*#__PURE__*/_react.default.createElement(PlaceholderContainer, null, placeholder) : /*#__PURE__*/_react.default.createElement(LabelContainer, null, currentLabel), [currentLabel, placeholder]);
  return /*#__PURE__*/_react.default.createElement(_BaseSelect.BaseSelect, _extends({
    value: currentValue,
    options: textOptions,
    component: label
  }, props));
}

var SelectField = props => (0, _withField.withField)(Select)(props);

exports.SelectField = SelectField;