"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SelectNative = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Icon = require("../Icon");

var _designparams = require("../designparams");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ArrowDown = () => {
  return /*#__PURE__*/_react.default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "24",
    height: "24",
    viewBox: "0 0 24 24"
  }, /*#__PURE__*/_react.default.createElement("path", {
    fill: "none",
    d: "M0 0h24v24H0V0z"
  }), /*#__PURE__*/_react.default.createElement("path", {
    d: "M8.71 11.71l2.59 2.59c.39.39 1.02.39 1.41 0l2.59-2.59c.63-.63.18-1.71-.71-1.71H9.41c-.89 0-1.33 1.08-.7 1.71z"
  }));
};

var getWidth = width => {
  switch (width) {
    case 'small':
      return '160px';

    case 'medium':
      return '200px';

    case 'large':
      return '300px';

    case 'full':
      return '100%';

    default:
      return '100%';
  }
};

var Container = _styledComponents.default.div.withConfig({
  displayName: "SelectNative__Container",
  componentId: "sc-1oiht1t-0"
})(["width:", ";display:flex;flex-direction:row;align-items:center;position:relative;color:", ";"], _ref => {
  var {
    width
  } = _ref;
  return getWidth(width);
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text05();
});

var IconContainer = _styledComponents.default.div.withConfig({
  displayName: "SelectNative__IconContainer",
  componentId: "sc-1oiht1t-1"
})(["position:absolute;right:8px;background-color:transparent;> svg{width:100%;height:100%;display:inline-block;}"]);

var NativeSelect = _styledComponents.default.select.withConfig({
  displayName: "SelectNative__NativeSelect",
  componentId: "sc-1oiht1t-2"
})(["height:", ";width:100%;color:", ";background-color:", ";border-width:0;border:1px solid transparent;border-radius:", ";padding:0 ", ";cursor:pointer;font-family:", ";font-size:", ";line-height:", ";&:hover{background-color:", ";}&:focus{outline:none;background-color:", ";border:1px solid ", ";}&:active{background-color:", ";border:1px solid transparent;}&:disabled{opacity:", ";pointer-events:none;}&:required:invalid{color:", ";}appearance:none;text-indent:1px;text-overflow:'';"], _designparams.componentSize.medium, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.text01();
}, _ref4 => {
  var {
    variant,
    theme
  } = _ref4;
  return variant === 'filled' ? theme.color.background02() : 'transparent';
}, _designparams.shape.radius.medium, _designparams.spacing.medium, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.font.family;
}, _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.font.size.regular;
}, _ref7 => {
  var {
    theme
  } = _ref7;
  return theme.font.lineHeight.large;
}, _ref8 => {
  var {
    variant,
    theme
  } = _ref8;
  return variant === 'filled' ? theme.color.background01() : theme.color.background02();
}, _ref9 => {
  var {
    variant,
    theme
  } = _ref9;
  return variant === 'filled' ? theme.color.background02() : 'transparent';
}, _ref10 => {
  var {
    theme
  } = _ref10;
  return theme.color.textPrimary();
}, _ref11 => {
  var {
    theme
  } = _ref11;
  return theme.color.background01();
}, _designparams.opacity[48], _ref12 => {
  var {
    theme
  } = _ref12;
  return theme.color.text01();
});

var OptionNative = _styledComponents.default.option.withConfig({
  displayName: "SelectNative__OptionNative",
  componentId: "sc-1oiht1t-3"
})(["color:", ";background-color:", ";&:disabled{color:", ";pointer-events:none;}"], _ref13 => {
  var {
    theme
  } = _ref13;
  return theme.color.text01();
}, _ref14 => {
  var {
    theme
  } = _ref14;
  return theme.color.background00();
}, _ref15 => {
  var {
    theme
  } = _ref15;
  return theme.color.text05();
});

var PlaceholderOption = _styledComponents.default.option.withConfig({
  displayName: "SelectNative__PlaceholderOption",
  componentId: "sc-1oiht1t-4"
})(["color:", ";background-color:", ";", ":required &[value=''][disabled]{display:none;}"], _ref16 => {
  var {
    theme
  } = _ref16;
  return theme.color.text05();
}, _ref17 => {
  var {
    theme
  } = _ref17;
  return theme.color.background00();
},
/* sc-selector */
NativeSelect);

var SelectNative = _ref18 => {
  var {
    value,
    options,
    onChange,
    name = '',
    required = true,
    width = 'full',
    variant = 'filled',
    placeholder = '',
    disabled = false
  } = _ref18,
      props = _objectWithoutProperties(_ref18, ["value", "options", "onChange", "name", "required", "width", "variant", "placeholder", "disabled"]);

  return /*#__PURE__*/_react.default.createElement(Container, {
    width: width
  }, /*#__PURE__*/_react.default.createElement(NativeSelect, _extends({
    name: name,
    value: value,
    onChange: onChange,
    disabled: disabled,
    required: required,
    variant: variant
  }, props), value === '' || placeholder !== '' ? /*#__PURE__*/_react.default.createElement(PlaceholderOption, {
    value: "",
    disabled: required
  }, placeholder) : undefined, options.map(option => /*#__PURE__*/_react.default.createElement(OptionNative, {
    key: option.value,
    value: option.value,
    disabled: option.disabled
  }, option.label))), /*#__PURE__*/_react.default.createElement(IconContainer, null, /*#__PURE__*/_react.default.createElement(_Icon.Icon, {
    icon: ArrowDown
  })));
};

exports.SelectNative = SelectNative;