"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StrengthIndicator = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Typography = require("../Typography");

var _designparams = require("../designparams");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Get a color that matches the strength level.
 * NOTE: these colors are directly taken from the
 * color palette as they are _not_ theme dependent.
 * Don't do this at home!
 *
 * @param strength The level of strength (between 0 and 1)
 */
var getStrengthColor = (strength, color) => {
  if (strength > 0.75) {
    return color.elementSuccess();
  }

  if (strength > 0.5) {
    return color.elementWarning();
  }

  if (strength > 0) {
    return color.elementError();
  }
};

var PasswordMeterContainer = _styledComponents.default.div.withConfig({
  displayName: "StrengthIndicator__PasswordMeterContainer",
  componentId: "sc-3tjdfc-0"
})(["background-color:", ";height:4px;width:240px;overflow:hidden;"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.background01();
});

var PasswordMeter = _styledComponents.default.div.attrs(_ref2 => {
  var {
    strength
  } = _ref2;
  return {
    style: {
      transform: "scaleX(".concat(strength, ")")
    }
  };
}).withConfig({
  displayName: "StrengthIndicator__PasswordMeter",
  componentId: "sc-3tjdfc-1"
})(["background-color:", ";height:100%;width:100%;transition:transform 0.3s ease-in-out;transform-origin:left center;"], _ref3 => {
  var {
    theme,
    strength
  } = _ref3;
  return getStrengthColor(strength, theme.color);
});

var PasswordWarning = _styledComponents.default.div.withConfig({
  displayName: "StrengthIndicator__PasswordWarning",
  componentId: "sc-3tjdfc-2"
})(["overflow:hidden;text-overflow:ellipsis;flex-shrink:1;margin-left:", ";line-height:0;color:", ";"], _designparams.spacing.large, _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.text01();
});

var PasswordStrengthIndicator = _styledComponents.default.div.withConfig({
  displayName: "StrengthIndicator__PasswordStrengthIndicator",
  componentId: "sc-3tjdfc-3"
})(["height:16px;width:100%;display:flex;align-items:center;"]);

var StrengthIndicator = _ref5 => {
  var {
    strength,
    helpText
  } = _ref5,
      props = _objectWithoutProperties(_ref5, ["strength", "helpText"]);

  return /*#__PURE__*/_react.default.createElement(PasswordStrengthIndicator, props, /*#__PURE__*/_react.default.createElement(PasswordMeterContainer, null, /*#__PURE__*/_react.default.createElement(PasswordMeter, {
    strength: strength
  })), /*#__PURE__*/_react.default.createElement(PasswordWarning, null, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: "navigation-label"
  }, helpText)));
};

exports.StrengthIndicator = StrengthIndicator;