"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LargeTableExample = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactHooksShareable = require("react-hooks-shareable");

var _practicalReactComponentsIcons = require("practical-react-components-icons");

var _Button = require("../Button");

var _Typography = require("../Typography");

var _Menu = require("../Menu");

var _GlobalScrollbarStyle = require("../Global/GlobalScrollbarStyle");

var _ = require(".");

var _TableCells = require("./TableCells");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TABLE_HEADER_DATA = [{
  id: 'serial-number',
  title: 'Serial number',
  width: 2
}, {
  id: 'name',
  title: 'Name',
  width: 1
}, {
  id: 'ip-address',
  title: 'IP address',
  width: 2
}];
var DEVICE_LIST = [{
  serialNumber: 'FACEFACE0001',
  name: 'a',
  ip: '192.168.0.1'
}, {
  serialNumber: 'FACEFACE0002',
  name: 'b',
  ip: '192.168.0.2'
}, {
  serialNumber: 'FACEFACE0003',
  name: 'c',
  ip: '192.168.0.3'
}, {
  serialNumber: 'FACEFACE0004',
  name: 'd',
  ip: '192.168.0.4'
}, {
  serialNumber: 'FACEFACE0005',
  name: 'e',
  ip: '192.168.0.5'
}, {
  serialNumber: 'FACEFACE0006',
  name: 'f',
  ip: '192.168.0.6'
}, {
  serialNumber: 'FACEFACE0007',
  name: 'g',
  ip: '192.168.0.7'
}, {
  serialNumber: 'FACEFACE0008',
  name: 'h',
  ip: '192.168.0.8'
}, {
  serialNumber: 'FACEFACE0009',
  name: 'i',
  ip: '192.168.0.9'
}, {
  serialNumber: 'FACEFACE0010',
  name: 'j',
  ip: '192.168.0.10'
}, {
  serialNumber: 'FACEFACE0011',
  name: 'k',
  ip: '192.168.0.11'
}, {
  serialNumber: 'FACEFACE0012',
  name: 'l',
  ip: '192.168.0.12'
}];
var LONG_DEVICE_LIST = [...DEVICE_LIST, ...DEVICE_LIST, ...DEVICE_LIST, ...DEVICE_LIST, ...DEVICE_LIST, ...DEVICE_LIST, ...DEVICE_LIST, ...DEVICE_LIST, ...DEVICE_LIST, ...DEVICE_LIST, ...DEVICE_LIST, ...DEVICE_LIST, ...DEVICE_LIST].map((device, index) => _objectSpread(_objectSpread({}, device), {}, {
  id: index.toString()
}));

var NOOP = () => {
  /** */
};

var onClickHandler = label => {
  return () => alert("clicked item: \"".concat(label, "\""));
};

var clickLogger = id => {
  return () => window.alert("You clicked on: ".concat(id));
};

var MENU_ITEMS = [{
  label: 'Item 1',
  onClick: NOOP
}, {
  label: 'Item 2',
  divider: true,
  onClick: NOOP
}, {
  label: 'Item 3',
  disabled: true,
  danger: true,
  onClick: NOOP
}];

var LargeTableExample = () => {
  var [selection, add, remove, reset] = (0, _reactHooksShareable.useSelection)();
  var [initialWidths] = (0, _react.useState)(TABLE_HEADER_DATA.map(_ref => {
    var {
      width
    } = _ref;
    return width;
  }));
  var onSelect = (0, _react.useCallback)((selected, id) => {
    if (selected) {
      if (id !== undefined) {
        add(id);
      } else {
        reset(LONG_DEVICE_LIST.map(device => device.id));
      }
    } else {
      if (id !== undefined) {
        remove(id);
      } else {
        reset([]);
      }
    }
  }, [add, remove, reset]);
  var [toggle, setToggle] = (0, _react.useState)(false);
  var toggleTest = (0, _react.useCallback)(() => {
    setToggle(!toggle);
  }, [toggle]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Button.Button, {
    label: "Run test",
    onClick: toggleTest
  }), /*#__PURE__*/_react.default.createElement(_GlobalScrollbarStyle.GlobalScrollbarStyle, null), toggle ? /*#__PURE__*/_react.default.createElement(_.Table, {
    initialWidths: initialWidths,
    resizableColumns: true,
    minColumnWidth: 0,
    maxHeight: 6,
    onSelect: onSelect,
    hasMenu: true
  }, /*#__PURE__*/_react.default.createElement(_.TableHeader, {
    selected: selection.size !== 0 && selection.size === LONG_DEVICE_LIST.length,
    partial: selection.size > 0 && selection.size < LONG_DEVICE_LIST.length,
    overlay: selection.size === 0 ? undefined : /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement(_Typography.Typography, null, "Actions overlay")),
    menu: /*#__PURE__*/_react.default.createElement(_Menu.Menu, {
      align: "right",
      items: MENU_ITEMS.map(_ref2 => {
        var {
          label
        } = _ref2,
            item = _objectWithoutProperties(_ref2, ["label"]);

        return _objectSpread(_objectSpread({}, item), {}, {
          label,
          onClick: onClickHandler(label)
        });
      })
    })
  }, TABLE_HEADER_DATA.map((_ref3, id) => {
    var {
      title
    } = _ref3;
    return /*#__PURE__*/_react.default.createElement(_TableCells.TableHeaderText, {
      key: id
    }, title);
  })), LONG_DEVICE_LIST.map((device, index) => {
    return /*#__PURE__*/_react.default.createElement(_.TableRow, {
      id: device.id,
      key: device.id,
      selected: selection.has(device.id),
      disabled: index === 2,
      menu: /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Menu.Menu, {
        icon: _practicalReactComponentsIcons.MoreIcon,
        align: "right",
        items: MENU_ITEMS.map(_ref4 => {
          var {
            label
          } = _ref4,
              item = _objectWithoutProperties(_ref4, ["label"]);

          return _objectSpread(_objectSpread({}, item), {}, {
            label,
            onClick: onClickHandler(label)
          });
        })
      })),
      clickable: index === 5,
      onClicked: clickLogger(device.id)
    }, /*#__PURE__*/_react.default.createElement(_Typography.Typography, null, device.serialNumber), /*#__PURE__*/_react.default.createElement(_Typography.Typography, null, device.name), /*#__PURE__*/_react.default.createElement(_Typography.Typography, null, device.ip));
  })) : null);
};

exports.LargeTableExample = LargeTableExample;