import React from 'react';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = React.HTMLAttributes<BaseElement>;
interface TableHeaderProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * Indicates if the all rows are selected.
     */
    readonly selected?: boolean;
    /**
     * Indicates if only a part of all rows are selected.
     */
    readonly partial?: boolean;
    /**
     * Optional overlay element to cover the column headers.
     */
    readonly overlay?: React.ReactNode;
    /**
     * Optional menu content to put on the right.
     * It will be aligned to the right and overflow onto the row.
     */
    readonly menu?: React.ReactNode;
}
export declare const TableHeader: React.FC<TableHeaderProps>;
export {};
