"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextAreaField = exports.TextArea = void 0;

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _designparams = require("../designparams");

var _utils = require("../utils");

var _Typography = require("../Typography");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var TEXT_AREA_HEIGHT = '96px';

var Error = _styledComponents.default.div.withConfig({
  displayName: "TextArea__Error",
  componentId: "sc-5zgztr-0"
})(["color:", ";line-height:16px;background-color:transparent;display:flex;align-items:center;position:absolute;left:0;right:0;bottom:0;top:0;pointer-events:none;"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.elementError();
});

var ErrorLineContainter = _styledComponents.default.div.withConfig({
  displayName: "TextArea__ErrorLineContainter",
  componentId: "sc-5zgztr-1"
})(["position:relative;box-sizing:border-box;border-bottom:1px solid ", ";height:100%;width:100%;flex-shrink:1;pointer-events:none;"], _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.elementError();
});

var ErrorLine = _styledComponents.default.div.withConfig({
  displayName: "TextArea__ErrorLine",
  componentId: "sc-5zgztr-2"
})(["position:absolute;bottom:-1px;height:2px;width:100%;background-color:transparent;border-radius:", ";"], _ref3 => {
  var {
    hasErrorMessage
  } = _ref3;
  return hasErrorMessage ? "".concat(_designparams.shape.radius.small, " 0 0 0") : "".concat(_designparams.shape.radius.small, " ").concat(_designparams.shape.radius.small, " 0 0");
});

var ErrorMessage = _styledComponents.default.div.withConfig({
  displayName: "TextArea__ErrorMessage",
  componentId: "sc-5zgztr-3"
})(["padding:0 8px;position:relative;bottom:-46px;pointer-events:none;"]);

var FocusLine = _styledComponents.default.div.withConfig({
  displayName: "TextArea__FocusLine",
  componentId: "sc-5zgztr-4"
})(["position:absolute;bottom:-2px;height:2px;width:100%;background-color:transparent;border-radius:", " ", " 0 0;"], _designparams.shape.radius.small, _designparams.shape.radius.small);

var TextAreaNative = _styledComponents.default.textarea.withConfig({
  displayName: "TextArea__TextAreaNative",
  componentId: "sc-5zgztr-5"
})(["font-family:", ";font-size:", ";line-height:", ";display:unset;box-sizing:border-box;width:100%;height:100%;color:", ";background-color:transparent;border-width:0;padding:", ";resize:none;&::placeholder{color:", ";}&:focus{outline:none;}&:read-only{opacity:", ";}"], _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.font.family;
}, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.font.size.regular;
}, _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.font.lineHeight.large;
}, _ref7 => {
  var {
    theme
  } = _ref7;
  return theme.color.text01();
}, _designparams.spacing.medium, _ref8 => {
  var {
    theme
  } = _ref8;
  return theme.color.text05();
}, _designparams.opacity[48]);

var TextAreaContainer = _styledComponents.default.div.withConfig({
  displayName: "TextArea__TextAreaContainer",
  componentId: "sc-5zgztr-6"
})(["height:", ";position:relative;flex:auto;box-sizing:border-box;border-width:0;background-color:", ";border-bottom:1px solid ", ";border-radius:", " ", " 0 0;padding-bottom:", ";&:hover{background-color:", ";border-bottom:1px solid ", ";}&:focus-within{background-color:", ";border-bottom:2px solid transparent;padding-bottom:7px;}&:focus-within ", "{background-color:", ";}&:focus-within ", "{background-color:", ";}&:focus-within ", "{border-bottom:1px solid transparent;}", " ", ";"], TEXT_AREA_HEIGHT, _ref9 => {
  var {
    theme
  } = _ref9;
  return theme.color.background02();
}, _ref10 => {
  var {
    theme
  } = _ref10;
  return theme.color.element11();
}, _designparams.shape.radius.medium, _designparams.shape.radius.medium, _designparams.spacing.medium, _ref11 => {
  var {
    theme
  } = _ref11;
  return theme.color.background01();
}, _ref12 => {
  var {
    theme
  } = _ref12;
  return theme.color.element01();
}, _ref13 => {
  var {
    theme
  } = _ref13;
  return theme.color.backgroundPrimary();
}, FocusLine, _ref14 => {
  var {
    theme
  } = _ref14;
  return theme.color.elementPrimary();
}, ErrorLine, _ref15 => {
  var {
    theme
  } = _ref15;
  return theme.color.elementError();
}, ErrorLineContainter, _ref16 => {
  var {
    disabled
  } = _ref16;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";&:hover{background-color:", ";border-bottom:1px solid ", ";}"], _designparams.opacity[48], _ref17 => {
    var {
      theme
    } = _ref17;
    return theme.color.background02();
  }, _ref18 => {
    var {
      theme
    } = _ref18;
    return theme.color.element11();
  }) : undefined;
}, _ref19 => {
  var {
    theme,
    hasError
  } = _ref19;
  return hasError ? (0, _styledComponents.css)(["background-color:", ";border-bottom:none;&:hover{background-color:", ";border-bottom:none;}&:focus-within{background-color:", ";padding-bottom:", ";border-bottom:none;}"], theme.color.backgroundError(), theme.color.backgroundError(), theme.color.backgroundError(), _designparams.spacing.medium) : undefined;
});

var TextArea = _ref20 => {
  var {
    onChange,
    onValueChange,
    onPressEnter,
    onPressEscape,
    disabled = false,
    error,
    onKeyUp,
    className,
    textareaRef
  } = _ref20,
      props = _objectWithoutProperties(_ref20, ["onChange", "onValueChange", "onPressEnter", "onPressEscape", "disabled", "error", "onKeyUp", "className", "textareaRef"]);

  var handleKeyUp = (0, _react.useCallback)(e => {
    onKeyUp === null || onKeyUp === void 0 ? void 0 : onKeyUp(e);

    switch (e.key) {
      case 'Enter':
        {
          onPressEnter === null || onPressEnter === void 0 ? void 0 : onPressEnter();
          break;
        }

      case 'Esc':
      case 'Escape':
        {
          onPressEscape === null || onPressEscape === void 0 ? void 0 : onPressEscape();
          break;
        }
    }
  }, [onPressEnter, onPressEscape, onKeyUp]);
  var handleChange = (0, _react.useCallback)(e => {
    onChange === null || onChange === void 0 ? void 0 : onChange(e);
    onValueChange === null || onValueChange === void 0 ? void 0 : onValueChange(e.target.value);
  }, [onChange, onValueChange]);
  return /*#__PURE__*/_react.default.createElement(TextAreaContainer, {
    className: className,
    disabled: disabled,
    hasError: error !== undefined
  }, /*#__PURE__*/_react.default.createElement(TextAreaNative, _extends({
    autoCorrect: "off",
    autoCapitalize: "off",
    spellCheck: false,
    rows: 3,
    disabled: disabled
  }, props, {
    onChange: handleChange,
    onKeyUp: handleKeyUp,
    ref: textareaRef
  })), error !== undefined ? /*#__PURE__*/_react.default.createElement(Error, null, /*#__PURE__*/_react.default.createElement(ErrorLineContainter, null, /*#__PURE__*/_react.default.createElement(ErrorLine, {
    hasErrorMessage: error !== ''
  })), error !== '' ? /*#__PURE__*/_react.default.createElement(ErrorMessage, null, /*#__PURE__*/_react.default.createElement(_Typography.Typography, {
    variant: "explanatory-text"
  }, error)) : null) : /*#__PURE__*/_react.default.createElement(FocusLine, null));
};

exports.TextArea = TextArea;
var TextAreaField = (0, _utils.withField)(TextArea);
exports.TextAreaField = TextAreaField;